﻿Public Class Form1

    Dim blankCell As List(Of String) = New List(Of String)()

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        C1FlexGrid1.Rows.Count = 1
        C1FlexGrid1.Cols.Count = 3

        C1FlexGrid1.Cols(1).Caption = "Name"
        C1FlexGrid1.Cols(2).Caption = "Country"

        C1FlexGrid1.AddItem(New String() {"John", "US"}, 1, 1)
        C1FlexGrid1.AddItem(New String() {"", "UK"}, 1, 1)
        C1FlexGrid1.AddItem(New String() {"Paul", "China"}, 1, 1)
        C1FlexGrid1.AddItem(New String() {"David", "Brazil"}, 1, 1)
        C1FlexGrid1.AddItem(New String() {"", "US"}, 1, 1)
        C1FlexGrid1.AddItem(New String() {"James", "US"}, 1, 1)

        C1FlexGrid1.DrawMode = C1.Win.C1FlexGrid.DrawModeEnum.OwnerDraw
        C1FlexGrid1.ShowSortPosition = C1.Win.C1FlexGrid.ShowSortPositionEnum.None
    End Sub

    Private Sub C1FlexGrid1_AfterSort(ByVal sender As Object, ByVal e As C1.Win.C1FlexGrid.SortColEventArgs) Handles C1FlexGrid1.AfterSort
        If (blankCell.Count > 0) Then
            Dim i As Integer = (blankCell.Count - 1)
            Do While (i >= 0)
                Dim newString() As String = System.Text.RegularExpressions.Regex.Split(blankCell(i), "" & vbTab)
                C1FlexGrid1.AddItem(New String() {newString(0), newString(1).ToString, newString(2).ToString})
                i = (i - 1)
            Loop
            blankCell.Clear()
        End If
    End Sub

    Private Sub C1FlexGrid1_BeforeSort(ByVal sender As Object, ByVal e As C1.Win.C1FlexGrid.SortColEventArgs) Handles C1FlexGrid1.BeforeSort
        Dim i As Integer = (C1FlexGrid1.Rows.Count - 1)
        Do While (i > 0)
            If ((C1FlexGrid1(i, e.Col) Is Nothing) _
                        OrElse (C1FlexGrid1(i, e.Col).ToString = "")) Then
                Dim rw As C1.Win.C1FlexGrid.Row = C1FlexGrid1.Rows(i)
                blankCell.Add(C1FlexGrid1.GetCellRange(i, 0, i, 2).Clip)
                C1FlexGrid1.Rows.Remove(rw)
            End If
            i = (i - 1)
        Loop
    End Sub

    Dim ht As C1.Win.C1FlexGrid.HitTestInfo
    Private Sub C1FlexGrid1_MouseClick(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles C1FlexGrid1.MouseClick
        If C1FlexGrid1.HitTest().Type = C1.Win.C1FlexGrid.HitTestTypeEnum.ColumnHeader Then
            ht = C1FlexGrid1.HitTest()
        End If
    End Sub

    Private Sub C1FlexGrid1_OwnerDrawCell(ByVal sender As Object, ByVal e As C1.Win.C1FlexGrid.OwnerDrawCellEventArgs) Handles C1FlexGrid1.OwnerDrawCell

        If e.Row = 0 And e.Col = ht.Column Then
            e.Style.ImageAlign = C1.Win.C1FlexGrid.ImageAlignEnum.RightCenter
            If C1FlexGrid1.Cols(e.Col).Sort = C1.Win.C1FlexGrid.SortFlags.Ascending Then
                e.Image = C1FlexGrid1.Glyphs(C1.Win.C1FlexGrid.GlyphEnum.Ascending)
            ElseIf C1FlexGrid1.Cols(e.Col).Sort = C1.Win.C1FlexGrid.SortFlags.Descending Then
                e.Image = C1FlexGrid1.Glyphs(C1.Win.C1FlexGrid.GlyphEnum.Descending)
            End If
        Else
            e.Image = Nothing
        End If

    End Sub
End Class
